#include "gr_esb_bridge.h"
#include "gr_esb_ui.h"
#include <unistd.h>

GR_ESB_bridge::GR_ESB_bridge(socexplorerplugin *parent) :
    abstractSpwBridge(parent)
{
    this->p_GUI = new GR_ESB_ui();
    this->Read_soc = new QTcpSocket(this);
    this->Write_soc = new QTcpSocket(this);
    connect((GR_ESB_ui*)(this->p_GUI),SIGNAL(ipchanged(QString)),this,SLOT(setIP(QString)));
    connect((GR_ESB_ui*)(this->p_GUI),SIGNAL(vlinkchanged(QString)),this,SLOT(setPort(QString)));
}

GR_ESB_bridge::~GR_ESB_bridge()
{
}

bool GR_ESB_bridge::connectBridge()
{
    int timeout=60;
    if(this->Read_soc->state()==QTcpSocket::UnconnectedState)
    {
        this->Read_soc->connectToHost(IP,gresb_Conf[virtualLinkIndex].Read_port);
        this->Read_soc->waitForConnected(30000);
    }
    if(this->Write_soc->state()==QTcpSocket::UnconnectedState)
    {
        this->Write_soc->connectToHost(IP,gresb_Conf[virtualLinkIndex].Write_port);
        this->Write_soc->waitForConnected(30000);
    }
    while((this->Read_soc->state()!=QTcpSocket::ConnectedState) && (this->Write_soc->state()!=QTcpSocket::ConnectedState))
    {
        usleep(100000);
        if(timeout--==0)return false;
    }
    return true;
}

bool GR_ESB_bridge::disconnectBridge()
{
    int timeout=60;
    if(this->Read_soc->state()!=QTcpSocket::UnconnectedState)
    {
        this->Read_soc->disconnectFromHost();
        this->Read_soc->waitForDisconnected(30000);
        while(this->Read_soc->state()!=QTcpSocket::UnconnectedState)
        {
            usleep(100000);
            if(timeout--==0)return false;
        }
    }
    return true;
}

void GR_ESB_bridge::setIP(QString ip)
{
    this->IP = ip;
}

void GR_ESB_bridge::setVirtualLink(QString vlink)
{
    vlink = vlink.section("Virtual link",0,0);
    bool success;
    int vlinkTmp = vlink.toInt(&success);
    if(success)
    {
        setVirtualLink(vlinkTmp);
    }
}

void GR_ESB_bridge::setVirtualLink(qint32 vlink)
{
    if(vlink<6 && vlink>=0)
    {
        virtualLinkIndex = vlink;
    }
}


unsigned int GR_ESB_bridge::Write(unsigned int *Value, unsigned int count, unsigned int address)
{

}

unsigned int GR_ESB_bridge::Read(unsigned int *Value, unsigned int count, unsigned int address)
{

}

int GR_ESB_bridge::pushRMAPPacket(char *packet, int size)
{

}
